/*
    A small test for png wrapper
*/

#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include "png_wrap.h"

int main(int argc,char *argv[])
{
    SDL_Event e;
    SDL_Surface *s;
    unsigned pix,*scr,n;
    PNG png;

    if(read_png(argv[1],&png))
    {
        printf("Ei se ny aukee\n");
        return(1);
    }

    printf("%dx%d ",png.x,png.y);
    switch(png.type)
    {
        case TYPE_GRAY: printf("harmaasaevy\n"); break;
        case TYPE_PALETTE: printf("indeksoitu\n"); break;
        case TYPE_RGB: printf("rgb\n"); break;
        case TYPE_RGBA: printf("rgba\n"); break;
        
        default: printf("ei tiatoo\n"); return(1);
    }

    SDL_Init(SDL_INIT_VIDEO);
    s=SDL_SetVideoMode(png.x,png.y,32,0);

    do
    {
        scr=s->pixels;

        if(png.type==TYPE_RGB)
            for(n=0;n<png.x*png.y;n++)
            {
                pix=png.data[n*3+0];
                pix<<=8;
                pix+=png.data[n*3+1];
                pix<<=8;
                pix+=png.data[n*3+2];
                scr[n]=pix;
            }

        if(png.type==TYPE_RGBA)
            for(n=0;n<png.x*png.y;n++)
            {
                pix=png.data[n*4+0];
                pix<<=8;
                pix+=png.data[n*4+1];
                pix<<=8;
                pix+=png.data[n*4+2];
                scr[n]=pix;
            }

        if(png.type==TYPE_GRAY)
            for(n=0;n<png.x*png.y;n++)
            {
                pix=png.data[n];
                pix<<=8;
                pix+=png.data[n];
                pix<<=8;
                pix+=png.data[n];
                scr[n]=pix;
            }

        if(png.type==TYPE_PALETTE)
            for(n=0;n<png.x*png.y;n++)
            {
                pix=png.pal[png.data[n]*3];
                pix<<=8;
                pix+=png.pal[png.data[n]*3+1];
                pix<<=8;
                pix+=png.pal[png.data[n]*3+2];
                scr[n]=pix;
            }

        SDL_Flip(s);
        SDL_PollEvent(&e);
    }
    while(e.type!=SDL_MOUSEBUTTONDOWN);

    SDL_Quit();
    return(0);
}
